// EncryptionLayer.cpp: implementation of the CEncryptionLayer class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SQLProxy.h"
#include "EncryptionLayer.h"


#include <string>
using namespace std;


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


#include "KeyMngmnt.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#define MAX_ALLOWED 1024*1024

char tmpBuf[MAX_ALLOWED];
char *pTmpBuf;
char *tmp_YMSG;
int sz_pkt;

CEncryptionLayer::CEncryptionLayer()
{

}

CEncryptionLayer::~CEncryptionLayer()
{

}

void CEncryptionLayer::GetTmpBuffer(char *&ch, int &sz)
{
	ch=pTmpBuf;
	sz=sz_pkt;
}


/* Protocol 
	evry message is like:
 !IX_YMCRYPT http://iit.iit.tuiasi.ro/~abss/ymcrypt RSA/DES 0xn=xxxxxxxx\n\r+message
	unde
	 0xn= 0x1 incep protocolul
		  0x2 ??	 


*/

/*
#define YM_MESSAGE_SIGN			"!IX_YMCRYPT "
#define YM_MESSAGE_SIGNATURE	"!IX_YMCRYPT http://www.geocities.com/abss2/SeQureLayerProxy "
#define YM_MESSAGE_CLICK		" Yes? click on http://www.geocities.com/abss2/SeQureLayerProxy"
#define MESSAGE
#define GETME_MESSAGE			"\nSomeone is watching you!? Are you sending sensitive messages with yahoo messenger? " 
#define YM_NOCRYPT				"!IX NO SECRET"
*/

#define YM_MESSAGE_SIGN			"!IX_YMCRYPT "
#define YM_MESSAGE_SIGNATURE	"!IX_YMCRYPT http://squrelayerproxy.sourceforge.net "
#define YM_MESSAGE_CLICK		" Yes? click on http://squrelayerproxy.sourceforge.net"
#define MESSAGE
#define GETME_MESSAGE			"\nSomeone is watching you!? Are you sending sensitive messages with yahoo messenger? " 
#define YM_NOCRYPT				"!IX NO SECRET"


#define MESSAGE_NUMBER_ADVERTISE	30

extern CKeyMngmnt kmgmnt;

void CEncryptionLayer::ComputeMessage(CString from_x, CString to_y, CString msg_in, CString &msg_out, BOOL LocalSide)
{	

	CString secret = kmgmnt.GetSecret(from_x,to_y);
	CString str;
	static int advertise=0;

	

	TRACE(from_x+" la "+to_y + "\n");
	if(secret != "" && !strnicmp((LPCSTR)msg_in,YM_NOCRYPT,strlen(YM_NOCRYPT)))
	{
		kmgmnt.DelSecret(from_x,to_y);
		secret = "";
	}

	if(secret != "")
	{
		if(LocalSide) 
		{
			if(!strncmp((LPCSTR)msg_in,YM_MESSAGE_SIGN,strlen(YM_MESSAGE_SIGN)))
			{
					str = ((LPCSTR)msg_in + strlen(YM_MESSAGE_SIGNATURE));
					msg_out = kmgmnt.DecryptString(from_x,to_y,str);
			}
			else msg_out = msg_in;
		}
		else msg_out = YM_MESSAGE_SIGNATURE + kmgmnt.EncryptString(from_x,to_y,msg_in);
	}
	else {
		CString adv="";
		if(!LocalSide)
		{
		advertise++;
			if(advertise == MESSAGE_NUMBER_ADVERTISE)
			{
				advertise=1;
				adv = CString() +GETME_MESSAGE + YM_MESSAGE_CLICK;
			}
		}
		msg_out = msg_in + adv;
	}
}

void CEncryptionLayer::PrepareYMSG(char *ch, int sz, BOOL LocalSide)
{
	int notclear=0;
if(sz>MAX_ALLOWED) {
		AfxMessageBox("Silly limit overrunned... submit a bug :)");
		tmpBuf[0]=0;
		sz_pkt=0;
		return ;
	}
	int old_sz=yahoo_get16(ch+8);
	if(yahoo_get16(ch+10) != 6) 	
	{		
		pTmpBuf = ch;
		sz_pkt = sz;		
		return ;
	}

/*		pTmpBuf = ch;
		sz_pkt = sz;	
	return ;*/

		pTmpBuf=tmpBuf;		

		char *pch=ch + YAHOO_PACKET_HDRLEN;		
		
		CString sender_name;
		CString destin_name;
		CString str_message;
		char *str_pos_b=NULL,*str_pos_e=NULL;

			for(int i=0;i<3;i++)
			switch(*pch)
			{
			case '1':			
					if(*(pch+1)=='4')
					{			
						pch+=4;
						str_pos_b=pch;									
						while((unsigned char)*pch!=0xc0 && (unsigned char)*(pch+1)!=0x80)
						{
							str_message +=*pch;
							pch++;			
						}
						str_pos_e=pch;
						pch+=2;						
					}
					else 
					{
						pch+=3;
						while((unsigned char)*pch!=0xc0 && (unsigned char)*(pch+1)!=0x80)
						{
							sender_name+=*pch;
							pch++;			
						}
						pch+=2;
					}

					break;
			case '4':			
					pch+=3;
						while((unsigned char)*pch!=0xc0 && (unsigned char)*(pch+1)!=0x80)
						{
							sender_name+=*pch;
							pch++;			
						}
					pch+=2;
				break;
			case '5':			
					pch+=3;
						while((unsigned char)*pch!=0xc0 && (unsigned char)*(pch+1)!=0x80)
						{
							destin_name+=*pch;
							pch++;			
						}
					pch+=2;
				break;
			default:
				//AfxMessageBox("Bug report... free to write silly messages! code error: WRONG or NEW PROTOCOL");
				notclear =1;						
			}

			if(notclear || destin_name == "" || sender_name == "" || str_message == "" || str_pos_b == NULL || str_pos_e == NULL)
			{
				pTmpBuf = ch;
				sz_pkt = sz;				
				return ; //well... well...
			}
		
		//	AfxMessageBox(sender_name+" to:  "+destin_name + " message:"+str_message );

			
			CString msg_new;
						
			ComputeMessage(sender_name,destin_name,str_message,msg_new,LocalSide);
			if(msg_new == "") msg_new = str_message + "possible error";
			int lng=str_pos_b-ch;
			memcpy(tmpBuf,ch,lng);
			memcpy(tmpBuf+lng,(LPCSTR)msg_new,msg_new.GetLength());
			lng+=msg_new.GetLength();
			int ramas=sz - (str_pos_e - ch);
			memcpy(tmpBuf+lng,str_pos_e,ramas);
			sz_pkt = lng + ramas; 
			int ysz	= old_sz + msg_new.GetLength() - str_message.GetLength();
			yahoo_put16(tmpBuf+8,ysz);
}



void CEncryptionLayer::Prepare_text_with_YMSG(char *ch, char *ch_YMSG, int sz,BOOL LocalSide)
{
	if(sz>MAX_ALLOWED) {
		AfxMessageBox("Silly limit overrunned... submit a bug :)");
		tmpBuf[0]=0;
		sz_pkt=0;
		return ;
	}


	if(yahoo_get16(ch_YMSG+10) != 6) 	
	{
		//strncpy(tmpbuf,ch,sz);
		pTmpBuf = ch;
		sz_pkt = sz;
		tmp_YMSG = ch_YMSG;
		return ;
	}

/*		pTmpBuf = ch;
		sz_pkt = sz;
		tmp_YMSG = ch_YMSG;
	return ;*/

		pTmpBuf=tmpBuf;
		tmp_YMSG = ch_YMSG;

		char *pch=ch_YMSG + YAHOO_PACKET_HDRLEN;
		char *final=pch+yahoo_get16(ch_YMSG+8);		
		
		CString sender_name;
		CString destin_name;
		CString str_message;
		char *str_pos_b=NULL,*str_pos_e=NULL;

			for(int i=0;i<3;i++)
			switch(*pch)
			{
			case '1':			
					if(*(pch+1)=='4')
					{			
						pch+=4;
						str_pos_b=pch;									
						while((unsigned char)*pch!=0xc0 && (unsigned char)*(pch+1)!=0x80)
						{
							str_message +=*pch;
							pch++;			
						}
						str_pos_e=pch;
						pch+=2;						
					}
					else 
					{
						pch+=3;
						while((unsigned char)*pch!=0xc0 && (unsigned char)*(pch+1)!=0x80)
						{
							sender_name+=*pch;
							pch++;			
						}
						pch+=2;
					}

					break;
			case '4':			
					pch+=3;
						while((unsigned char)*pch!=0xc0 && (unsigned char)*(pch+1)!=0x80)
						{
							sender_name+=*pch;
							pch++;			
						}
					pch+=2;
				break;
			case '5':			
					pch+=3;
						while((unsigned char)*pch!=0xc0 && (unsigned char)*(pch+1)!=0x80)
						{
							destin_name+=*pch;
							pch++;			
						}
					pch+=2;
				break;
			default:
				AfxMessageBox("Bug report... free to write silly messages! code error: WRONG or NEW PROTOCOL");
				return ;
			}

			if(destin_name=="" || sender_name=="" || str_message == "" || str_pos_b == NULL || str_pos_e == NULL)					
			{
				pTmpBuf = ch;
				sz_pkt = sz;
				tmp_YMSG = ch_YMSG;
				return ; //well... well...
			}
		
		//	AfxMessageBox(sender_name+" to:  "+destin_name + " message:"+str_message );

			
			CString msg_new;
			int oldsz=yahoo_get16(ch_YMSG+8);			
			
			ComputeMessage(sender_name,destin_name,str_message,msg_new,LocalSide);
			int lng=str_pos_b-ch;
			memcpy(tmpBuf,ch,lng);
			memcpy(tmpBuf+lng,(LPCSTR)msg_new,msg_new.GetLength());
			lng+=msg_new.GetLength();
			int ramas=ch_YMSG + oldsz - str_pos_e;
			//oldsz-(str_pos_e-ch_YMSG-YAHOO_PACKET_HDRLEN)
			memcpy(tmpBuf+lng,str_pos_e,ramas);
			sz_pkt = lng + ramas; 
			int ysz	= oldsz + msg_new.GetLength() - str_message.GetLength();
			yahoo_put16(tmpBuf+(ch_YMSG-ch)+8,ysz);
			if(ysz!=yahoo_get16(tmpBuf+(ch_YMSG-ch)+8)) AfxMessageBox("error");
}


