// KeyMngmnt.cpp: implementation of the CKeyMngmnt class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SQLProxy.h"
#include "KeyMngmnt.h"
#include "Protocols.h"

#include <string>
using namespace std;

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


#define FOLDER_NAME		"scdata\\"
#define USERS_FILE		FOLDER_NAME"users.dat"
#define SECRETS_FILE    FOLDER_NAME"ymsqlscrts.dat"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CKeyMngmnt::CKeyMngmnt()
{
	LoadSecrets();
	CreateDirectory(FOLDER_NAME,NULL);
}

CKeyMngmnt::~CKeyMngmnt()
{
	SaveSecrets();
}

void convert_stringToCString(string s,CString &outs)
{
	const char *str=s.c_str();
	outs=str;
}

CString CKeyMngmnt::EncryptString(const CString &from,const  CString &to,const CString &in)
{
	string st;
	CString out;
	CString s=GetSecret(from,to);	
	
	if(s != "") st=DES_EncryptString(in,s);
	else return in;
	convert_stringToCString(st,out);
	return out;
}

CString CKeyMngmnt::DecryptString(const CString &from,const CString &to,const  CString &in)
{
	string st;
	CString out;
	CString s=GetSecret(from,to);	
	
	if(s !="") st=DES_DecryptString(in,s);
	else return in;
	convert_stringToCString(st,out);
	return out;	
}

CKeyMngmnt kmgmnt;


int CKeys::LoadKeys(const CString &name)
{
 return 0;
}

void CKeys::GenerateKeys(CString &name,CString &seed)
{
	
}


CString CKeyMngmnt::GetSecret(CString u1,CString u2)
{
	CString u;
	CString secret;
	if(u1<u2) u=u1+u2;
	else u = u2+u1;
	if(m_secrets.Lookup(u,secret))
		return secret;
	else return "";
}



void MaskBuffer(char *buf)
{
	while(*buf) { *buf=~*buf;buf++;};
}

void CKeyMngmnt::SaveSecrets()
{
	
	CString key;
	CString value;
	FILE *f= fopen(SECRETS_FILE,"wb+");
	char buf[1024];

	POSITION pos = m_secrets.GetStartPosition();
	while (pos != NULL)
	{	   
	   m_secrets.GetNextAssoc(pos,key,value);
	   sprintf(buf,"%s %s",(LPCSTR)key,(LPCSTR)value);
	   int l=strlen(buf);
	   MaskBuffer(buf);	   
	   fwrite(&l,1,sizeof(int),f);
	   fwrite(buf,1,l,f);
	}
	fclose(f);

	f= fopen(USERS_FILE,"wb+");	
	void *v;
	pos = m_map.GetStartPosition();
	while (pos != NULL)
	{	   
	   m_map.GetNextAssoc(pos,key,v);
	   sprintf(buf,"%s",(LPCSTR)key);
	   int l=strlen(buf);
	   MaskBuffer(buf);	   
	   fwrite(&l,1,sizeof(int),f);
	   fwrite(buf,1,l,f);
	}
	fclose(f);
}


void CKeyMngmnt::LoadSecrets()
{
   m_secrets.RemoveAll();
	FILE *f= fopen(SECRETS_FILE,"rb");
	char buf[1024];
	char *pk,*pv;
	CString key;
	CString value;
	int l,sz;

	while (f && !feof(f))
	{
	   sz=fread(&l,1,sizeof(int),f);
	   if(sz!=sizeof(int)) break;
	   fread(buf,1,l,f);
	   buf[l] = 0;
	   MaskBuffer(buf);
	    pk=buf;
		pv=buf;
	   while(*pv != ' ') pv++;
	   *pv='\0';
	   pv++;
	   key=pk;
	   value = pv;
	   m_secrets.SetAt(key,value);
	}
	if(f) fclose(f);

	CString *pkey;
	f= fopen(USERS_FILE,"rb");
	while (f && !feof(f))
	{
	   sz=fread(&l,1,sizeof(int),f);
	   if(sz!=sizeof(int)) break;
	   fread(buf,1,l,f);
	   buf[l] = 0;
	   MaskBuffer(buf);
	   pkey = new CString(buf);
	   m_map.SetAt(*pkey,(void *)pkey);
	}
	if(f) fclose(f);

}

void CKeyMngmnt::AddSecret(CString u1, CString u2,CString pass)
{	
	CString u;
	if(u1<u2) u=u1+u2;
	else u = u2+u1;
	m_secrets.SetAt(u,pass);
}

void CKeyMngmnt::DelSecret(CString &u1, CString &u2)
{
	CString u;
	if(u1<u2) u=u1+u2;
	else u = u2+u1;
	m_secrets.RemoveKey(u);
}

void CKeyMngmnt::AddUser(CString &s)
{
	void *v;
	if(s == "") return;
	if(!m_map.Lookup(s,v))
	{
		CString *pkey = new CString(s);
		m_map.SetAt(s,pkey);
	}
}
