// Protocols.h: interface for the CProtocols class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PROTOCOLS_H__B5F31B32_0C05_4216_A50A_87BAB201BC21__INCLUDED_)
#define AFX_PROTOCOLS_H__B5F31B32_0C05_4216_A50A_87BAB201BC21__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
using namespace std;

const int MAX_PHRASE_LENGTH=250;

void GenerateRSAKey(unsigned int keyLength, const char *privFilename, const char *pubFilename, const char *seed);

char *RSAEncryptString(const char *pubFilename, const char *seed, const char *message);
char *RSADecryptString(const char *privFilename, const char *ciphertext);

string DES_EncryptString(const char *plaintext, const char *passPhrase);
string DES_DecryptString(const char *ciphertext, const char *passPhrase);

void GzipFile(const char *in, const char *out, int deflate_level);
void GunzipFile(const char *in, const char *out);


/*

#define yahoo_put16(buf, data) ( \
		(*(buf) = (u_char)((data)>>8)&0xff), \
		(*((buf)+1) = (u_char)(data)&0xff),  \
		2)
#define yahoo_get16(buf) ((((*(buf))<<8)&0xff00) + ((*((buf)+1)) & 0xff))
#define yahoo_put32(buf, data) ( \
		(*((buf)) = (u_char)((data)>>24)&0xff), \
		(*((buf)+1) = (u_char)((data)>>16)&0xff), \
		(*((buf)+2) = (u_char)((data)>>8)&0xff), \
		(*((buf)+3) = (u_char)(data)&0xff), \
		4)
#define yahoo_get32(buf) ((((*(buf))<<24)&0xff000000) + \
		(((*((buf)+1))<<16)&0x00ff0000) + \
		(((*((buf)+2))<< 8)&0x0000ff00) + \
		(((*((buf)+3)    )&0x000000ff)))


#define BUFMAX 10240

class Buffer
{
	 char *buf;
	 int begin;
	 int size;
	 int max;
 public:

 void Realoc(int nsz)
 {
	char *nb=new char[nsz];
	memcpy(nb,buf+begin,size);
	max = nsz;
	begin=0;
	delete buf;
	buf=nb;
 }
 void Add(const void *b,int sz)
 {	
	 if(size+sz>max) 
	 {
		 int ofs;
		 if(begin<1024) ofs=1024;
		 else ofs=0;
		 Realoc(size+sz+ofs);
	 }
	 memcpy(buf+begin+size,b,sz);
	 size+=sz;
 }
 void *Sub(int sz)
 {
	int ob=begin;
	begin+=sz;
	return buf+ob;
 }
 int GetSize(){
	 return size;
 }
 Buffer()
	{
	begin=0;
	size=0;
	buf=new char[BUFMAX];
	max=BUFMAX;
	}

 int DetectYMSG(char *&ch)
 {
	ch=buf+begin;
		while(ch-buf-begin<size) 
		if(*ch=='Y' && *(ch+1) =='M' && *(ch+2) =='S' && *(ch+3) =='G') break;
		else ch++;
	if(ch-buf-begin==size) return -1;
	else return ch-buf-begin;
 }

  CString GetHostAndPort(int &port)
  {
    port=80;
	CString s;
	char *ch=buf+begin;
	while(ch-buf-begin<size) 
		if(*ch=='h' && *(ch+1) =='t' && *(ch+2) =='t' && *(ch+3) =='p' 
					&& *(ch+4) ==':' && *(ch+5) =='/' && *(ch+6) =='/') break;
		else ch++;
	if(ch-buf-begin==size) return "";
	ch+=7;
	while(ch-buf-begin<size) 
		if(*ch!=':' && *ch!='/') 
			{
			s+=*ch;
			ch++;
			}
		else break;
	if(ch-buf-begin==size) return "";
	if(*ch==':')
		{
		port=0;
		ch++;
		while(ch-buf-begin<size) 
			if(*ch>='0' && *ch<='9') 
				{
				port*=10;
				port+=*ch - '0';
				ch++;
				}
			else break;
		}
	return s;
  }
  ~Buffer()
  {
	  delete buf;
  }
};


*/
class CProtocols  
{
public:
	CProtocols();
	virtual ~CProtocols();

};

#endif // !defined(AFX_PROTOCOLS_H__B5F31B32_0C05_4216_A50A_87BAB201BC21__INCLUDED_)
