// ProxyBuffer.cpp: implementation of the CProxyBuffer class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SQLProxy.h"
#include "ProxyBuffer.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CProxyBuffer::CProxyBuffer()
{
	begin=0;
	size=0;
	buf=new char[BUFMAX];
	max=BUFMAX;
}

CProxyBuffer::~CProxyBuffer()
{
delete buf;
}

void CProxyBuffer::Realoc(int nsz)
 {
	char *nb=new char[nsz];
	memcpy(nb,buf+begin,size);
	max = nsz;
	begin=0;
	delete buf;
	buf=nb;
 }
 void CProxyBuffer::Add(const void *b,int sz)
 {	
	 if(size+sz>max) 
	 {
		 int ofs;
		 if(begin<1024) ofs=1024;
		 else ofs=0;
		 Realoc(size+sz+ofs);
	 }
	 memcpy(buf+begin+size,b,sz);
	 size+=sz;
	 *((char *)buf+begin+size) = 0;
 }
 void *CProxyBuffer::Sub(int sz)
 {
	if(size<sz) 
	{		
		return NULL;
	}
	
	int ob=begin;
	begin+=sz;
	size-=sz;
	return buf+ob;
 }

 void * CProxyBuffer::SubAll(int &sz)
 {
    if(size==0) 
	{
		sz=0;
		return NULL;
	}
	int ob=begin;
	begin+=size;
	sz=size;
	size=0;
	return buf+ob;
 }

 int CProxyBuffer::GetSize(){
	 if(size>max) return 0;
	 return size;
 }




 int CProxyBuffer::DetectYMSG_test_packt(char *&ch,char *&ch_YMSG,int &sz)
 {
	ch=buf+begin;
		while(ch-buf-begin<size) 
			if(*ch=='Y' && *(ch+1) =='M' && *(ch+2) =='S' && *(ch+3) =='G') break;
		else ch++;
	int cit=ch-buf-begin;
	if(cit==size) return 0;	
    if(cit+YAHOO_PACKET_HDRLEN>size) return 0;
    if((sz=cit+YAHOO_PACKET_HDRLEN+yahoo_get16(ch+8))>size)	return 0;
	ch_YMSG = ch;
	ch=buf+begin;	
	return 1;
 }

 
int CProxyBuffer::GetNextYMSG_Message(char *&ch, int &sz)
{
  if(!size)return 0;
  ch=buf+begin;  
  if(*ch!='Y' || *(ch+1) !='M' || *(ch+2) !='S' || *(ch+3) !='G') return 0;
  char *pch=ch;
	pch++;
	while(pch-buf-begin<size) 
			if(*pch=='Y' && *(pch+1) =='M' && *(pch+2) =='S' && *(pch+3) =='G') break;
		else pch++;
	sz=pch-ch;
	return 1;
}



void *CProxyBuffer::GetUntil_any_YMSG(int &sz)
{
	char *ch;
	if(size==0) return NULL;
	ch=buf+begin;
		while(ch-buf-begin<size) 
			if(*ch=='Y' && *(ch+1) =='M' && *(ch+2) =='S' && *(ch+3) =='G') break;
		else ch++;
		if(ch-buf-begin==size) 
		{
			sz=size;
			return buf+begin;
		}
		else
		{			
			sz=ch-buf-begin; // hmm..
			return buf+begin;
		}
	//possible bug -- if YMSG comming in diffrent series :) not probabilly
}



CString CProxyBuffer::GetHostAndPort(int &port)
  {
    port=80;
	CString s;
	char *ch=buf+begin;
	while(ch-buf-begin<size) 
		if(*ch=='h' && *(ch+1) =='t' && *(ch+2) =='t' && *(ch+3) =='p' 
					&& *(ch+4) ==':' && *(ch+5) =='/' && *(ch+6) =='/') break;
		else ch++;
	if(ch-buf-begin==size) return "";
	ch+=7;
	while(ch-buf-begin<size) 
		if(*ch!=':' && *ch!='/' && *ch!=' ') 
			{
			s+=*ch;
			ch++;
			}
		else break;
	if(ch-buf-begin==size) return "";
	if(*ch==':')
		{
		port=0;
		ch++;
		while(ch-buf-begin<size) 
			if(*ch>='0' && *ch<='9') 
				{
				port*=10;
				port+=*ch - '0';
				ch++;
				}
			else break;
		}
	return s;
  }




void * CProxyBuffer::GetRowBuf()
{
  return buf+begin;
}

#define CONT_LNG "Content-Length: "

void CProxyBuffer::AdjustContentLength(int delta)
{
	if(delta==0) return;
	//stupid code -- should be replaced later with a general aproach about HTML headers request
	//or using CString as buf :) -- is not so fast but is not realy a problem
	// sometimes i think that using a C style is better than CString... sometimes is not so...:)
	int gasit=0;
	char *ch=buf+begin;

	while(ch-buf-begin<size)
	{
		ch++;
		if(!strncmp(ch,CONT_LNG,strlen(CONT_LNG))) 
		{
			gasit=1;
			break;
		}

	}

	if(!gasit) return;
	char *nb=new char[max];
	int lng=ch-buf-begin;
	memcpy(nb,buf+begin,lng);
	memcpy(nb+lng,CONT_LNG,strlen(CONT_LNG));
	lng+=strlen(CONT_LNG);
	ch+=strlen(CONT_LNG);
	int sz=0;
	int x=0;
	while(*ch!='\n' && *ch!='\r') 
		{
			sz*=10;
			sz+=*ch-'0';
			x++;
			ch++;
		}	
	// *ch!='\n' && *(ch+1)!='\n' && *(ch+2)!='\r' 
	sz+=delta;
	char tbuf[10];
	sprintf(tbuf,"%d",sz); 
	memcpy(nb+lng,tbuf,strlen(tbuf));
	int ramas=size-lng-x;
	lng+=strlen(tbuf);	
	memcpy(nb+lng,ch,ramas);

	size+=delta;
	begin=0;
	delete buf;
	buf=nb;

}
