// SQLProxyDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SQLProxy.h"
#include "SQLProxyDlg.h"
#include "CriptProperties.h"
#include "AddNewSecret.h"
#include "process.h"
#include "BlockedSocket.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSQLProxyDlg dialog


CSQLProxyDlg *appDlg;

#define REGKEY "settings"

CSQLProxyDlg::CSQLProxyDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSQLProxyDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSQLProxyDlg)
	m_remoteadress = _T("");
	m_port = 0;
	m_ports = 0;
	m_bLog = FALSE;
	m_bServer = FALSE;
	m_bYahoo = FALSE;
	m_bCrypt = FALSE;
	m_bRegistryRegistered = FALSE;
	m_localadress = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	CWinApp *app=AfxGetApp();
	//app->SetRegistryKey(1);
	char buf[1024];
		if(gethostname(buf,1000)!=0) strcpy(buf,"127.0.0.1");		
	m_hIcon = app->LoadIcon(IDR_MAINFRAME);
	m_bLog = app->GetProfileInt(REGKEY,"m_bLog",1);
	m_bYahoo = app->GetProfileInt(REGKEY,"m_bYahoo",1);
	m_bServer = app->GetProfileInt(REGKEY,"m_bServer",1);
	m_bCrypt = app->GetProfileInt(REGKEY,"m_bCrypt",1);
	m_port = app->GetProfileInt(REGKEY,"port_dest",8080);
	m_ports = app->GetProfileInt(REGKEY,"port_src",5050);
	m_bRegistryRegistered = app->GetProfileInt(REGKEY,"registered",0);
	//m_strMethod=app->GetProfileString(REGKEY,"CryptMethod","RSA+DES");
	m_localadress  = app->GetProfileString(REGKEY,"HostAdress",buf);
	m_remoteadress = app->GetProfileString(REGKEY,"RemoteProxyAdress","localhost");
	m_proxy = NULL;
	
	appDlg=this;

}


BOOL CSQLProxyDlg::DestroyWindow() 
{
	UpdateData();
	CWinApp *app=AfxGetApp();	
	app->WriteProfileInt(REGKEY,"m_bLog",m_bLog);
	app->WriteProfileInt(REGKEY,"m_bYahoo",m_bYahoo);
	app->WriteProfileInt(REGKEY,"m_bServer",m_bServer);
	app->WriteProfileInt(REGKEY,"m_bCrypt",m_bCrypt);
	app->WriteProfileInt(REGKEY,"port_dest",m_port);
	m_ports=app->WriteProfileInt(REGKEY,"port_src",m_ports);
	//app->WriteProfileString(REGKEY,"CryptMethod",m_strMethod)
	app->WriteProfileString(REGKEY,"RemoteProxyAdress",m_remoteadress);	
	app->WriteProfileString(REGKEY,"HostAdress",m_localadress);
	app->WriteProfileInt(REGKEY,"registered",m_bRegistryRegistered);
	return CDialog::DestroyWindow();
}



int GetGlobalIntProperty(CString s)
{
 if(s=="log") return appDlg->m_bLog;
 if(s=="Yahoo") return appDlg->m_bYahoo;
 if(s=="server") return appDlg->m_bServer;
 if(s=="remote_port") return appDlg->m_port;
 return -1;
}

CString GetGlobalStringProperty(CString s)
{
 //if(s=="CryptMethod") return appDlg->m_strMethod;
 if(s=="remote_HostAdress") return appDlg->m_remoteadress;
 return "";
}


void SetInfoText(CString str)
{

appDlg->GetDlgItem(IDC_INFO)->SetWindowText(str);
//DoLog("data\\app_log",(LPCSTR)str,str.GetLength(),0);
}


void CSQLProxyDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSQLProxyDlg)
	DDX_Text(pDX, IDC_SERVER, m_remoteadress);
	DDX_Text(pDX, IDC_PORT, m_port);
	DDX_Text(pDX, IDC_PORT_S, m_ports);
	DDX_Check(pDX, IDC_CHECK_LOG, m_bLog);
	DDX_Check(pDX, IDC_CHECK_SERVER, m_bServer);
	DDX_Check(pDX, IDC_CHECK_YAHOO, m_bYahoo);
	DDX_Check(pDX, IDC_CHECK_CRYPT, m_bCrypt);
	DDX_Text(pDX, IDC_LOCALADRESS, m_localadress);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSQLProxyDlg, CDialog)
	//{{AFX_MSG_MAP(CSQLProxyDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_BUTTON_DISMISS, OnButtonDismiss)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK_SERVER, OnCheckServer)	
	ON_BN_CLICKED(IDC_OPTIONS, OnOptions)
	ON_BN_CLICKED(IDC_BUTTON_QUERYLOG, OnButtonQuerylog)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON_REGISTER, OnButtonRegister)	
	ON_BN_CLICKED(IDC_ADDSECRET, OnAddsecret)
	ON_BN_CLICKED(IDC_HELP, OnHelp)	
	ON_BN_CLICKED(IDC_WEB, OnWeb)
	ON_BN_CLICKED(IDC_BUTTON_UNREGISTER, OnButtonRegister)
	ON_BN_CLICKED(IDC_HELPME, OnHelpme)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSQLProxyDlg message handlers

BOOL CSQLProxyDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	SetTimer(1, 2000, 0);
	OnCheckServer();
	GetDlgItem(IDC_STOP)->EnableWindow(FALSE);	

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSQLProxyDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSQLProxyDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


CBlockedSocket block;

void CSQLProxyDlg::OnStart() 
{
	UpdateData();
	m_proxy=new CSProxy;	
	m_proxy->m_IServer=TRUE;
	if(m_proxy->Create(m_ports) && 	m_proxy->Listen()) 
	{
		GetDlgItem(IDC_START)->EnableWindow(FALSE);
		GetDlgItem(IDC_STOP)->EnableWindow(TRUE);
	}
	block.Create(5101);
	block.Listen();
	
}

void CSQLProxyDlg::OnStop() 
{
	if(m_proxy)
		{
		m_proxy->Close();
		delete m_proxy;
		m_proxy=NULL;
		}
	GetDlgItem(IDC_START)->EnableWindow(TRUE);
	GetDlgItem(IDC_STOP)->EnableWindow(FALSE);
	block.Close();
}

void CSQLProxyDlg::OnButtonDismiss() 
{
  OnStop();	
  OnClose();
  exit(1);
}



void CSQLProxyDlg::OnTimer(UINT nIDEvent) 
{

    SetInfoText("Idle...");
	CDialog::OnTimer(nIDEvent);
}

void CSQLProxyDlg::OnCheckServer() 
{
	UpdateData();
	if(m_bServer) 
	{
		GetDlgItem(IDC_SERVER)->EnableWindow(FALSE);
		GetDlgItem(IDC_PORT)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_SERVER)->EnableWindow();
		GetDlgItem(IDC_PORT)->EnableWindow();
	}
	
	if(m_bRegistryRegistered) 
	{
		GetDlgItem(IDC_BUTTON_REGISTER)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON_UNREGISTER)->EnableWindow(TRUE);
	}
	else
	{
		GetDlgItem(IDC_BUTTON_REGISTER)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON_UNREGISTER)->EnableWindow(FALSE);
	}

}

/*
void CSQLProxyDlg::OnButtonAsk() 
{

	char buf[10240];
	Buffer *b;
//	CFileDialog dlg(TRUE);
	//dlg.DoModal();
	


   CFileFind finder;
   BOOL bWorking = finder.FindFile("I:\\dilaog_full\\log__*.*");
   FILE *f;
   while (bWorking)
   {
      bWorking = finder.FindNextFile();      
	 CString fn=(LPCSTR)(finder.GetFilePath());// + "\\"+finder.GetFileName());
	 //f=fopen(dlg.GetFileName(),"r");
	f=fopen(fn,"r");
	if(!f) continue;
	int sz=fread(buf,1,10240,f);
	fclose(f);
	b = new Buffer();
	b->Add(buf,sz);
	char *ch;
	CString prot;
	CString str;
	if(b->DetectYMSG(ch)!=-1) 
	{	
		prot.Format("YMSG PAKET from %s:\n len=%d,service=%d,status=%d,pkt_id=%d,\ncomponents: ",
						(LPCSTR)fn,yahoo_get16(ch+8),yahoo_get16(ch+10),
							yahoo_get16(ch+12),yahoo_get16(ch+16)
						);
		char *pch=ch+18;
		char *final=ch+20+yahoo_get16(ch+8);
		char *pi;
		char buf[10240];
		while(pch<final)
		{
			pi=pch;
			while((unsigned char)*pch!=0xc0 && (unsigned char)*(pch+1)!=0x80)
				pch++;
			strncpy(buf,pi,pch-pi);
			buf[pch-pi]=0;
			prot+=buf;
			prot+="\n";
			pch+=2;
		}
		f=fopen("logs_dialog_full","a+");
		if(f) fprintf(f,"Log %s\n",LPCSTR(prot));
		fclose(f);
		delete b;
		//AfxMessageBox(prot);
	}
   }

}
*/

void CSQLProxyDlg::OnOptions() 
{

	CCriptProperties prop;
	prop.DoModal();
}


char buf[1024*1024];	

void CSQLProxyDlg::OnButtonQuerylog() 
{

	return ;
	char *ch;	
	CString prot;

	CFileDialog dlg(TRUE);	
	dlg.DoModal();
	FILE *f=fopen(dlg.GetFileName() ,"r");	
	int sz=fread(buf,1,1024*1024,f);
	fclose(f);
	CProxyBuffer proxyBuf;
	proxyBuf.Add(buf,sz);


	void *rest=proxyBuf.GetUntil_any_YMSG(sz);
			if(rest)
				{					
					proxyBuf.Sub(sz);
				}
			while(proxyBuf.GetNextYMSG_Message(ch,sz))
			{																	
				prot.Format("YMSG PAKET from ?? \n len=%d,service=%d,status=%d,pkt_id=%d\nComponents:\n",
						yahoo_get16(ch+8),yahoo_get16(ch+10),
						yahoo_get16(ch+12),yahoo_get16(ch+16));

				char *pch=ch+20;
				char *final=ch+20+yahoo_get16(ch+8);
				char *pi;
				char buf[10240];
				while(pch<final)
				{
					pi=pch;
					while(pch<final && (unsigned char)*pch!=0xc0 && (unsigned char)*(pch+1)!=0x80)
						pch++;
					if(pch==final)
					{
						prot+="..unfinished...\n";
					}
					strncpy(buf,pi,pch-pi);
					buf[pch-pi]=0;
					prot+=buf;
					prot+="\n";
					pch+=2;
				}
					proxyBuf.Sub(sz);
				DoLog("QueryFile.txt",(LPCSTR)prot,prot.GetLength());
			}

}





void CSQLProxyDlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
		
}

#define YAHOO_REGKEY "Software\\Yahoo\\Pager"
//HKEY_CURRENT_USER\Software\Yahoo\Pager


#define NOERROR_ATALL -100000

int ret;
void ShowError(DWORD err=NOERROR_ATALL )
{
	if(err == NOERROR_ATALL ) err = GetLastError();
	LPVOID lpMsgBuf;
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | 
		FORMAT_MESSAGE_FROM_SYSTEM | 
		FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL,
		err,
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		(LPTSTR) &lpMsgBuf,
		0,
		NULL 
	);

	// Process any inserts in lpMsgBuf.
	// ...
	// Display the string.
	MessageBox( NULL, (LPCTSTR)lpMsgBuf, "Error", MB_OK | MB_ICONINFORMATION );
	// Free the buffer.
	LocalFree( lpMsgBuf );
}

DWORD tmp;
#define ABSS_REGSET_STRING(hkey,nume,value,sz) if((ret = RegSetValueEx(hkey,nume,0,REG_SZ,(CONST BYTE *)value,sz)) != ERROR_SUCCESS) ShowError(ret);
#define ABSS_REGSET_INT(hkey,nume,value) tmp = value;if((ret = RegSetValueEx(hkey,nume,0,REG_DWORD	,(CONST BYTE *)&tmp,sizeof(DWORD))) != ERROR_SUCCESS) ShowError(ret);

void CSQLProxyDlg::OnButtonRegister() 
{
	UpdateData();
	char buf[1024];
		if(gethostname(buf,1000)!=0) strcpy(buf,"127.0.0.1");
	CWinApp *app=AfxGetApp();	

	if(!m_bRegistryRegistered)
	{		

		HKEY hKey;
		if(RegOpenKeyEx(HKEY_CURRENT_USER,YAHOO_REGKEY,0,KEY_WRITE|KEY_READ|KEY_SET_VALUE,&hKey)==ERROR_SUCCESS)
		{

		DWORD nr=m_localadress.GetLength()+1;
		char *bs= m_localadress.GetBuffer(nr);
		
		ABSS_REGSET_STRING(hKey,"HTTP Proxy",bs,nr);	
		ABSS_REGSET_INT(hKey,"Proxy Port",m_ports);		
		ABSS_REGSET_INT(hKey,"Proxy Enabled",1);		
		ABSS_REGSET_INT(hKey,"Enable PTP",0);	 
		  RegCloseKey(hKey); 
		}			
			CString msg;
			msg.Format("I hope that Yahoo Messenger is not running!\
\nYou can also configure a proxy for yahoo from \
Login\\Preferences\\Use Proxy (yahoo menus)\n \
Http proxy [Server name = %s] [Server port = %d] ",buf,m_ports);
			AfxMessageBox(msg);		
			msg.Format("Also with regedit check <Enable PTP> ,<Proxy Enabled> , <HTTP Proxy> and <Proxy Port>registry keys  in %s","HKEY_CURRENT_USER\\Software\\Yahoo\\Pager");
			AfxMessageBox(msg);				
	}
	else 
		{
			HKEY hKey;
			if(RegOpenKeyEx(HKEY_CURRENT_USER,YAHOO_REGKEY,0,KEY_WRITE|KEY_READ|KEY_SET_VALUE,&hKey)==ERROR_SUCCESS)
			{				
				ABSS_REGSET_INT(hKey,"Proxy Enabled",0);
				ABSS_REGSET_INT(hKey,"Enable PTP",1);
				AfxMessageBox("Done!");
			}
			  RegCloseKey(hKey); 
		}			
	m_bRegistryRegistered = !m_bRegistryRegistered;
	OnCheckServer();
}


void CSQLProxyDlg::OnAddsecret() 
{
	CAddNewSecret dlg;
	dlg.DoModal();
}

void CSQLProxyDlg::OnHelp() 
{

}

void CSQLProxyDlg::OnGotoweb() 
{	
}

void CSQLProxyDlg::OnWeb() 
{
	STARTUPINFO si;
    PROCESS_INFORMATION pi;

    ZeroMemory( &si, sizeof(si) );
    si.cb = sizeof(si);
    ZeroMemory( &pi, sizeof(pi) );
	AfxMessageBox("MessengersPrivacy (SQLProxy) \
is a project aimed for adding more privacy to users of existing \
messengers (first Yahoo Messenger and later MSN, ICQ), also other \
proxy and security features will be implemented in the same program. \
In first version, only yahoo messenger protocol is supported.\n\
Go at http://squrelayerproxy.sourceforge.net for details");
	CreateProcess( NULL, // No module name (use command line). 
        "explorer http://squrelayerproxy.sourceforge.net", // Command line. 
        NULL,             // Process handle not inheritable. 
        NULL,             // Thread handle not inheritable. 
        FALSE,            // Set handle inheritance to FALSE. 
        0,                // No creation flags. 
        NULL,             // Use parent's environment block. 
        NULL,             // Use parent's starting directory. 
        &si,              // Pointer to STARTUPINFO structure.
        &pi );           

}

void CSQLProxyDlg::OnHelpme() 
{
	
}
